//---------------------------------------------------------------------------
#pragma hdrstop

#include "EXECryptor.h"
#include <string.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)

#ifdef USE_API
extern "C" DWORD _stdcall _export EXECryptor_GetDate()
{
  FILETIME t1,t2;
  WORD dt,tt;
  GetSystemTimeAsFileTime(&t1);
  FileTimeToLocalFileTime(&t1,&t2);
  FileTimeToDosDateTime(&t2,&dt,&tt);
  return dt;
}

void SafeGetDate(int *Day, int *Month, int *Year)
{
  DWORD dt = EXECryptor_GetDate();
  *Day = dt & 0x1F;
  *Month = (dt >> 5) & 0xF;
  *Year = (dt >> 9)+1980;
}

DWORD _stdcall _export EXECryptor_GetHardwareID()
{
  asm {
    db 090h,090h,090h,090h
  };
  return 0;
}

void _stdcall _export EXECryptor_EncryptStr(const char *Src, char *Dst)
{
  strcpy(Dst,Src);
}

void _stdcall _export EXECryptor_DecryptStr(const char *Src, char *Dst)
{
  strcpy(Dst,Src);
}

const
  char *TestKeyPath = "Software\\EXECryptorTestKeys";

bool _stdcall _export EXECryptor_SecureWrite(const char *Name, const char *Value)
{
  DWORD Disposition;
  HKEY KeyHandle;
  if (RegCreateKeyExA(HKEY_CURRENT_USER, TestKeyPath, 0, NULL,
      REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &KeyHandle, &Disposition) == ERROR_SUCCESS) {
    RegSetValueExA(KeyHandle, Name, 0, REG_BINARY, (CONST BYTE*)Value, strlen(Value)+1);
    RegCloseKey(KeyHandle);
    return true;
  } else
    return false;
}

bool _stdcall _export EXECryptor_SecureRead(const char *Name, char *Value)
{
  HKEY KeyHandle;
  DWORD sz,tp;
  bool Result = false;
  *Value=0;
  if (RegOpenKeyExA(HKEY_CURRENT_USER, TestKeyPath, 0, KEY_QUERY_VALUE, &KeyHandle) == ERROR_SUCCESS) {
    tp=REG_BINARY;
    if (RegQueryValueExA(KeyHandle, Name, NULL, &tp, NULL, &sz) == ERROR_SUCCESS) {
      RegQueryValueExA(KeyHandle, Name, NULL, &tp, (BYTE*)Value, &sz);
      Result=true;
    }
    RegCloseKey(KeyHandle);
  };
  return Result;
}

int _stdcall _export EXECryptor_MessageBoxA(HWND hWnd, LPCSTR lpText,
  LPCSTR lpCaption, UINT uType)
{
  return MessageBoxA(hWnd, lpText, lpCaption, uType);
}

FARPROC _stdcall _export EXECryptor_GetProcAddr(HMODULE hModule, LPCSTR lpProcName)
{
  return GetProcAddress(hModule, lpProcName);
}

void _stdcall _export EXECryptor_AntiDebug()
{
  asm {
    db 090h,090h,090h,090h,090h
  };
}

void _stdcall _export EXECryptor_ProtectImport()
{
  asm {
    db 090h,090h,090h,090h,090h
  };
}
#endif

#ifdef USE_CRYPT_REG
#ifdef USE_STD_SERIALS

TVerifyResult _stdcall _export EXECryptor_VerifySerialNumber(const char *RegistrationName,
  const char *SerialNumber, int CurrentYear, int CurrentMonth,
  TSerialNumberInfo *SNInfo, const char *HardwareID)
{
  asm {
    db 090h,090h,090h,090h
  };
  return vrOK;
}

#else

void _stdcall _export EXECryptor_SetCodeKey(const void *Key, int Size)
{
  asm {
    db 090h,090h,090h,090h
  };
}

#endif

TVerifyResult _stdcall _export EXECryptor_IsRegistered()
{
  asm {
    db 090h,090h,090h,090h
  };
  return vrOK;
}

DWORD _stdcall _export EXECryptor_RegConst_0()
{
  asm {
    db 090h,090h,090h,090h
  };
  return 0;
}

DWORD _stdcall _export EXECryptor_RegConst_1()
{
  asm {
    db 090h,090h,090h,090h
  };
  return 1;
}

DWORD _stdcall _export EXECryptor_RegConst_2()
{
  asm {
    db 090h,090h,090h,090h
  };
  return 2;
}

DWORD _stdcall _export EXECryptor_RegConst_3()
{
  asm {
    db 090h,090h,090h,090h
  };
  return 3;
}

DWORD _stdcall _export EXECryptor_RegConst_4()
{
  asm {
    db 090h,090h,090h,090h
  };
  return 4;
}

DWORD _stdcall _export EXECryptor_RegConst_5()
{
  asm {
    db 090h,090h,090h,090h
  };
  return 5;
}

DWORD _stdcall _export EXECryptor_RegConst_6()
{
  asm {
    db 090h,090h,090h,090h
  };
  return 6;
}

DWORD _stdcall _export EXECryptor_RegConst_7()
{
  asm {
    db 090h,090h,090h,090h
  };
  return 7;
}
#endif



